{ File mplot.v  September 2000

   Copyright (c) 2000   D. R. Williamson

   Revised May 2001
   Revised June 2004
   Revised July 2006
}
\-----------------------------------------------------------------------

\  Plotting.
   X11 not IF halt THEN

   "plotWCB" missing
   IF "plot.v" source
      pgrid_off graphpair \ initial settings

      \yes "pGRID" "GRID" bank, 45 32 pgrid_space

   THEN

   no is updated \ word newday (mday.v) will be run to update files

\  2 LineSolid plotGCattrib \ line width 
\  0 LineSolid plotGCattrib \ line width 
   1 LineSolid plotGCattrib \ line width 

\  Window size and placement:
\  600 plotWCB wcb.w poke \ window width
\  450 plotWCB wcb.h poke \ window height
\  186 plotWCB wcb.x poke \ upper left corner at x on screen
\  0 plotWCB wcb.y poke \ upper left corner at y on screen

\  Tall and skinny:
   390 plotWCB wcb.w poke \ window width
   500 plotWCB wcb.h poke \ window height
   400 plotWCB wcb.x poke \ upper left corner at x on screen
   0 plotWCB wcb.y poke \ upper left corner at y on screen

\  Short and wide:
   786 plotWCB wcb.w poke \ window width
   440 plotWCB wcb.h poke \ window height
   0 plotWCB wcb.x poke \ upper left corner at x on screen
   0 plotWCB wcb.y poke \ upper left corner at y on screen

   inline: left_win ( --- )
      [ 390 is w_width, 430 is w_height ]
      w_width  plotWCB wcb.w poke \ window width
      w_height plotWCB wcb.h poke \ window height

      0 plotWCB wcb.x poke \ upper left corner at x on screen
      0 plotWCB wcb.y poke \ upper left corner at y on screen
   end

   inline: maxrm (hC --- hC1) \ remove max curve and adjust lines/colors
      [ "maxfetch" ptr is fcn ]
      this one endmost fcn exe lop lop
      1st them cows items swap
      those rows teeth rake lop (hL) \ list of items wanted

      this push catch (hC1) \ catching wanted columns
      pLines peek reach (hLines) \ reaching wanted lines and colors
      pColors pull reach (hColors)
      graphset
   end

   inline: -max (hC n --- hC1) \ remove n max curves, adjust colors
      1st DO maxrm LOOP ;

   inline: minrm (hC --- hC1) \ remove min curve and adjust lines/colors
      [ "minfetch" ptr is fcn, "maxfetch" ptr is putback ]
      fcn "maxrm" "fcn" bank maxrm
      putback "maxrm" "fcn" bank
   end

   inline: -min (hC n --- hC1) \ remove n min curves, adjust colors
      1st DO minrm LOOP ;

   inline: right_win ( --- )
      "left_win" "w_width"  yank plotWCB wcb.w poke \ window width
      "left_win" "w_height" yank plotWCB wcb.h poke \ window height

      "left_win" "w_width" yank 10 + plotWCB wcb.x poke \ upper left
      0 plotWCB wcb.y poke \ upper left corner at y on screen
   end

\  Buttons.

   inline: dCursor1 (hData hXY --- hData) \ show Data for loc in graph
\     Displays Y from Data nearest to the given X,Y coordinates.
\     Assumes graph reflects Data on stack; Data remains on stack.

      true 1 MAT stkok and, 2 MAT stkok and not
      IF dCursor3 return THEN \ use dCursor3 if no Data on stack

      "Name" main is Name

      this 1st pry integer, 1st max
      other (hData) rows ndx min "X" book

      2nd pry integer "Y" book

      (hData) this X reach bend  \ row from Data into vector
      yes sort Y nearest Name prices @ "Y" book

      Name
{ NO LONGER DONE
         its "JY" alike
         IF Y "%6.2f" format nl sp . 1E4 Y / "%6.2fY" format sp . ELSE

         its "SF" alike
         IF Y "%6.2f" format nl sp . 1E4 Y / "%6.2fSf" format sp . ELSE

         its "DM" alike
         IF Y "%6.2f" format nl sp . 1E4 Y / "%6.2fDm" format sp . ELSE
}
        [
         "(nN --- qN) dup 0> IF '+' swap intstr + ELSE intstr THEN"
         "intsigned" macro
        ]
\        default:
         Y over priceformat1 nl sp .

\        THEN THEN THEN
      drop

\     Delivery month from DATA:
      Months DATA X those rows min (row) data.delmo fetch
      100 / integer quote sp dot

\     Date from DATA:
      X DATA rows >
      IF date sysdate drop
      ELSE DATA X data.date fetch
      THEN sp sp date2$ dot

      nl cprompt . \ show console prompt
   end

\  Installing ptr to word dCursor1 as the Button1 (left) function in
\  word pButton of file plot.v:
   "dCursor1" ptr "pButton" "Button1" bank \ left button function

   inline: dCursor1.2 (hData hXY --- hData) \ show Data for loc in graph
\     Run by server 2 to plot data in graph 2.

\     Displays Y from Data nearest to the given X,Y coordinates.
\     Assumes graph reflects Data on stack; Data remains on stack.

      true 1 MAT stkok and, 2 MAT stkok and not
      IF dCursor3 return THEN \ use dCursor3 if no Data on stack

      "Name" main is Name

      this 1st pry integer, 1st max
      other (hData) rows ndx min "X" book

      2nd pry integer "Y" book

      (hData) this X reach bend  \ row from Data into vector
      yes sort Y nearest @ intstr nl sp .

\     Delivery month from DATA:
      Months DATA X those rows min (row) data.delmo fetch
      100 / integer quote sp dot

\     Date from DATA:
      X DATA rows >
      IF date sysdate drop
      ELSE DATA X data.date fetch
      THEN sp sp date2$ dot

      nl cprompt . \ show console prompt
   end

   inline: dCursor2 (hXY --- ) \ display values for location in graph
\     Display the raw XY values corresponding to cursor location in
\     graph.

      dup 1st pry "i" book

      bend " x, y: %2.0f, %2.0f " format nl .

      nl cprompt . \ show console prompt
   end

\  Installing ptr to word dCursor2 as the Button2 (middle) function in
\  word pButton of file plot.v:
   "dCursor2" ptr "pButton" "Button2" bank \ mid button function

   inline: dCursor3 (hXY --- ) \ display values for location in graph
      (hXY) this 2nd pry "Name" main prices " %6.2f" format nl .
      (hXY) 1st pry integer, 1st max DATA rows ndx min "i" book

\     Fetching date from DATA:
      DATA data.date catch i pry sp sp date2$ .

      nl cprompt . \ show console prompt
   end

\  Installing ptr to word dCursor3 as the Button3 (right) function in
\  word pButton of file plot.v:
   "dCursor3" ptr "pButton" "Button3" bank \ right button function

\  Function run by SERVER 2, displaying TMAT (see mday.n):
   inline: dCursorTMAT (hXY --- ) \ display values for location in graph
      (hXY) this 2nd pry (Y) " %6.2f" format nl .
      (hXY) 1st pry integer, 1st max DATA rows ndx min (i)

\     Fetching date from DATA:
      DATA data.date catch swap (i) pry sp sp date2$ .

      nl cprompt . \ show console prompt

   end

   private halt

\-----------------------------------------------------------------------
 
\  Words for display:
 
\  Default functions:
   'SHOW sl' 
\  'SHOW 30l' 
\  'SHOWcg sl pause SHOW 20l' 
\  'SHOWP 30l'
\  'SHOW_Uce_Vce sl'
\  'SHOW_Uce_Vce sl mpath Name lowercase ".txt" cat cat asciiload eview'
\  'SHOWcluster sl'
\  '16 8 SHOW2 sl'
\  'OCT sl'
\  'SHOW sl'
\  'SHOWdef sl'
\  'SHOWxy sl'
\  'SHOW sl SHOW1 pause sl'
\  'pgrid_off graphpair1 "G2" main 6 mo last pause sl'
\'pgrid_off graphpair1 "G2" main 1st 3 items catch "G2" main 4th 9 items catch bend colsort bend park 6 mo last pause sl'
\  'pgrid_off oct1f 60 mo last pause oct1 yl pause 6 mo last'
\  'pgrid_off 5 octN yl pause 6 mo last pause ql'
\  'pgrid_off octall yl pause 6 mo last pause ql'
\  'pgrid_off oct1 yl pause 6 mo last pause ql'
\  'pgrid_off oct yl pause 6 mo last pause ql'
\  'pgrid_off wf3 yl pause 6 mo last pause ql'
\  'pgrid_off wf1 yl pause 6 mo last pause ql'
\  'pgrid_off wf1 yl pause 6 mo last pause ql'
\  'pgrid_off views yl pause 6 mo last pause sl'
\  'pgrid_off wf yl pause 6 mo last pause sl'
\  'pgrid_off tiers sl pause 33 last'
\  'pgrid_off tiers yl pause sl'
\  'pgrid_off tiers yl pause pgrid sl'
\  'mxmn sl'
\  'rid sl pause 30l'
\   'gsi sl pause 30l pause hsi sl'
   spaced "std" book

\  Below is the plot function used when zz is brought up by word func
\  of mday.v.  Edit the phrase of inlinex zz() below as required for
\  a new view when things change.

\  Note that each phase must be quoted so a ptr to a quote string is 
\  returned by word fplot when it is run by word func (see mday.v).

      std quoted "dj()" inlinex
      std quoted "sp()" inlinex
      std quoted "nq()" inlinex
      std quoted "yx()" inlinex
      std quoted "nk()" inlinex

      std quoted "us()" inlinex
      std quoted "tn()" inlinex
      std quoted "tb()" inlinex
      std quoted "ff()" inlinex
      std quoted "ed()" inlinex

      std quoted "sf()" inlinex
      std quoted "dm()" inlinex
      std quoted "eu()" inlinex
      std quoted "jy()" inlinex
      std quoted "mp()" inlinex
      std quoted "bp()" inlinex

      std quoted "ct()" inlinex
      std quoted "cl()" inlinex
      std quoted "ho()" inlinex
      std quoted "hu()" inlinex
      std quoted "ng()" inlinex

      std quoted "hg()" inlinex
      std quoted "gc()" inlinex
      std quoted "pl()" inlinex
      std quoted "si()" inlinex

      std quoted "cc()" inlinex
      std quoted "kc()" inlinex
      std quoted "sb()" inlinex
      std quoted "jo()" inlinex

      std quoted "lc()" inlinex
      std quoted "lh()" inlinex
      std quoted "pb()" inlinex

      std quoted "w()" inlinex
      std quoted "c()" inlinex
      std quoted "s()" inlinex
      std quoted "sm()" inlinex
      std quoted "bo()" inlinex

\-----------------------------------------------------------------------

   inline: fplot (qS --- ptr) \ pointer to plot function for S
      [
      list:

      "DJ" str2num "dj()" ptr
      "SP" str2num "sp()" ptr
      "NQ" str2num "nq()" ptr
      "YX" str2num "yx()" ptr
      "NK" str2num "nk()" ptr

      "US" str2num "us()" ptr
      "TN" str2num "tn()" ptr
      "TB" str2num "tb()" ptr
      "FF" str2num "ff()" ptr
      "ED" str2num "ed()" ptr

      "SF" str2num "sf()" ptr
      "DM" str2num "dm()" ptr
      "EU" str2num "eu()" ptr
      "JY" str2num "jy()" ptr
      "MP" str2num "mp()" ptr
      "BP" str2num "bp()" ptr

      "CT" str2num "ct()" ptr
      "CL" str2num "cl()" ptr
      "HO" str2num "ho()" ptr
      "HU" str2num "hu()" ptr
      "NG" str2num "ng()" ptr

      "HG" str2num "hg()" ptr
      "GC" str2num "gc()" ptr
      "PL" str2num "pl()" ptr
      "SI" str2num "si()" ptr

      "CC" str2num "cc()" ptr
      "KC" str2num "kc()" ptr
      "SB" str2num "sb()" ptr
      "JO" str2num "jo()" ptr

      "LC" str2num "lc()" ptr
      "LH" str2num "lh()" ptr
      "PB" str2num "pb()" ptr

      "W" str2num "w()" ptr
      "C" str2num "c()" ptr
      "S" str2num "s()" ptr
      "SM" str2num "sm()" ptr
      "BO" str2num "bo()" ptr
      end

      these rows two slash matrix yes sort (hList)

      "_fplot" book 
      ]
      uppercase _fplot that str2num bsearch
      IF lop _fplot swap two fetch
      ELSE drop sp dot " not found" dot drop no
      THEN
   end

   private halt

\-----------------------------------------------------------------------

;  Appendix

   Empty functions:

      std quoted "dj()" inlinex
      std quoted "sp()" inlinex
      std quoted "nq()" inlinex
      std quoted "yx()" inlinex
      std quoted "nk()" inlinex

      std quoted "us()" inlinex
      std quoted "tn()" inlinex
      std quoted "tb()" inlinex
      std quoted "ff()" inlinex
      std quoted "ed()" inlinex

      std quoted "sf()" inlinex
      std quoted "dm()" inlinex
      std quoted "eu()" inlinex
      std quoted "jy()" inlinex
      std quoted "mp()" inlinex
      std quoted "bp()" inlinex

      std quoted "ct()" inlinex
      std quoted "cl()" inlinex
      std quoted "ho()" inlinex
      std quoted "hu()" inlinex
      std quoted "ng()" inlinex

      std quoted "hg()" inlinex
      std quoted "gc()" inlinex
      std quoted "pl()" inlinex
      std quoted "si()" inlinex

      std quoted "cc()" inlinex
      std quoted "kc()" inlinex
      std quoted "sb()" inlinex
      std quoted "jo()" inlinex

      std quoted "lc()" inlinex
      std quoted "lh()" inlinex
      std quoted "pb()" inlinex

      std quoted "w()" inlinex
      std quoted "c()" inlinex
      std quoted "s()" inlinex
      std quoted "sm()" inlinex
      std quoted "bo()" inlinex

